<template>
  <div class="text-right">
    <v-dialog v-model="dialog" persistent height="auto" width="1100">
      <template v-slot:activator="{ on, attrs }">
        <v-btn
          class="
            button-text
            v-btn v-btn--outlined v-btn--rounded
            theme--light
            v-size--default
            tway-violet--text
          "
          color="coral lighten-2"
          outlined
          v-bind="attrs"
          v-on="on"
        >
          <v-icon
            color="deep-orange accent-4

"
          >
            mdi-chart-areaspline
          </v-icon>

          Seguimiento
        </v-btn>
      </template>

      <v-card :class="'modalSystem'">
        <v-card>
          <div class="container">
            <v-btn icon right @click="dialog = false" class="float-right">
              <v-icon>mdi-close</v-icon>
            </v-btn>
            <h3 class="text-center">SEGUIMIENTO DE AGILIDAD</h3>
            <h4 class="text-center font-weight-regular">
              Ingresa nuevo Seguimiento
            </h4>
            <v-simple-table class="table mt-5" fixed-header>
              <template>
                <thead>
                  <tr>
                    <th class="text-center" width="150" scope="col">Fecha</th>
                    <th class="text-center" width="20%" scope="col">
                      Eficiencia
                    </th>
                    <th class="text-center" width="20%" scope="col">
                      Velocidad
                    </th>
                    <th class="text-center" width="20%" scope="col">
                      Predictibilidad
                    </th>
                    <th class="text-center" width="15%" scope="col">
                      Tiempo de Ciclo
                    </th>
                    <th class="text-center" width="150" scope="col">
                      Acciones
                    </th>
                  </tr>
                </thead>
                <tbody>
                  <tr
                    :v-if="items.length > 0"
                    v-for="(item, index) in items"
                    :key="index"
                    :class="item.isVisible ? activeClass : hidden"
                    class="edit_row"
                  >
                    <td class="text-center">
                      <v-menu
                        ref="menu"
                        v-model="item.menu"
                        :close-on-content-click="true"
                        :return-value.sync="date"
                        transition="scale-transition"
                        offset-y
                        max-width="290px"
                        min-width="auto"
                      >
                        <template v-slot:activator="{ on, attrs }">
                          <v-text-field
                            v-model="item.date"
                            label="Mes / Año"
                            prepend-icon="mdi-calendar"
                            readonly
                            outlined
                            v-bind="attrs"
                            v-on="on"
                          ></v-text-field>
                        </template>
                        <v-date-picker
                          v-model="item.date"
                          type="month"
                          no-title
                          scrollable
                        >
                        </v-date-picker>
                      </v-menu>
                    </td>
                    <td class="text-center">
                      <v-text-field
                        v-model="item.eficiencia"
                        label="Eficiencia"
                        maxlength="15"
                        minlenght="0"
                        :counter="15"
                        outlined
                      ></v-text-field>
                    </td>
                    <td class="text-center">
                      <v-text-field
                        v-model="item.velocidad"
                        label="Velocidad"
                        maxlength="15"
                        minlenght="0"
                        :counter="15"
                        outlined
                      ></v-text-field>
                    </td>
                    <td class="text-center">
                      <v-text-field
                        v-model="item.predictibilidad"
                        label="Predictibilidad"
                        maxlength="15"
                        minlenght="0"
                        :counter="15"
                        outlined
                      ></v-text-field>
                    </td>
                    <td class="text-center">
                      <v-text-field
                        v-model="item.tiempoCiclo"
                        label="Tiempo de Ciclo"
                        maxlength="15"
                        minlenght="0"
                        :counter="15"
                        outlined
                      ></v-text-field>
                    </td>
                    <td class="text-center buttons">
                      <v-tooltip right>
                        <template v-slot:activator="{ on, attrs }">
                          <v-btn
                            icon
                            color="primary"
                            class="edit"
                            @click="saveItem(item)"
                            v-bind="attrs"
                            v-on="on"
                          >
                            <v-icon>edit</v-icon>
                          </v-btn>
                        </template>
                        <span>Editar</span>
                      </v-tooltip>
                      <v-tooltip right>
                        <template v-slot:activator="{ on, attrs }">
                          <v-btn
                            icon
                            color="primary"
                            class="save"
                            @click="saveItem(item)"
                            v-bind="attrs"
                            v-on="on"
                          >
                            <v-icon>save</v-icon>
                          </v-btn>
                        </template>
                        <span>Guardar</span>
                      </v-tooltip>
                      <v-tooltip right>
                        <template v-slot:activator="{ on, attrs }">
                          <v-btn
                            icon
                            color="error"
                            v-bind="attrs"
                            v-on="on"
                            @click="removeItem()"
                          >
                            <v-icon>delete</v-icon>
                          </v-btn>
                        </template>
                        <span>Eliminar</span>
                      </v-tooltip>
                    </td>
                  </tr>
                </tbody>
              </template>
            </v-simple-table>
            <v-row>
              <v-col md="12" class="justify-center">
                <div class="btn d-flex justify-center mt-6">
                  <v-btn
                    class="
                      button-text
                      v-btn v-btn--outlined v-btn--rounded
                      theme--light
                      v-size--default
                      tway-violet--text
                      justify-center
                    "
                    outlined
                    color="indigo lighten-2"
                    @click="AddItem()"
                  >
                    <v-icon color="purple"> mdi-plus </v-icon>
                    Agregar otro
                  </v-btn>
                </div>
              </v-col>
            </v-row>
          </div>
        </v-card>
      </v-card>
    </v-dialog>
  </div>
</template>

<script>
export default {
  data() {
    return {
      dialog: false,
      items: [
        {
          eficiencia: "",
          velocidad: 0,
          predictibilidad: "",
          tiempoCiclo: 0,
          date: new Date().toISOString().substr(0, 7),
          menu: false,
        },
      ],
      nameRules: [
        (v) => !!v || "Requerido.",
        (v) => v.length <= 15 || "Máximo 15 carácteres.",
      ],
      isVisible: true,
      activeClass: "is-visible",
    };
  },
  methods: {
    AddItem() {
      this.items.push({
        eficiencia: this.eficiencia,
        velocidad: this.velocidad,
        predictibilidad: this.predictibilidad,
        tiempoCiclo: this.tiempoCiclo,
        date: this.date,
      });
    },
    removeItem() {
      if (this.items.length > 1) {
        this.items.splice(this.items, 1);
      }
    },
    saveItem(item) {
      item.isVisible = !item.isVisible;
      this.$forceUpdate();
    },
  },
};
</script>

<style>
.shrink {
  width: 150px;
}
.bar {
  width: 350px;
}
.modalSystem {
  border-radius: 0px !important;
}
.v-menu__content.theme--light.v-menu__content--fixed.menuable__content__active {
  background-color: #fff;
}
.modalSystem .v-card.v-sheet.theme--light {
  padding: 20px 40px;
}
.modalSystem label.v-label.theme--light,
.edit_row .v-text-field__details {
  font-family: "Josefin Sans", sans-serif !important;
}
.modalSystem fieldset {
  border-color: #4a148c !important;
}
.modalSystem label.v-label--active {
  color: #4a148c !important;
}
.modalSystem button.v-btn.primary {
  background-color: #4a148c !important;
  border-color: #4a148c !important;
}
.edit_row .v-input__slot,
.edit_row .v-select {
  min-height: 35px !important;
  max-height: 35px !important;
  margin-bottom: 0px !important;
}
.edit_row .v-text-field--outlined .v-label {
  top: 8px;
  font-size: 13px !important;
}
.edit_row .v-input__append-inner {
  margin-top: 5px !important;
}
.edit_row .v-text-field__details {
  display: none;
}
.edit_row .v-select__selection,
.edit_row .v-text-field__slot input {
  font-size: 0.875rem;
}
.edit_row label.v-label.v-label--active.theme--light {
  top: 18px;
}
tr.edit_row td {
  height: 60px !important;
}
.modalSystem .edit_row fieldset {
  border-color: #fff !important;
  background-color: #f2f2f2;
}
.modalSystem .v-data-table__wrapper {
  max-height: 408px;
  overflow: auto;
}
.modalSystem .edit_row.is-visible fieldset {
  border-color: transparent !important;
  background-color: transparent;
}
.modalSystem button.float-right {
  z-index: 9;
  top: 15px;
  right: 15px;
  position: absolute;
}
.modalSystem .edit_row .v-input__prepend-outer {
  display: none;
}
.peso {
  float: left;
  margin-right: 5px;
  top: 7px;
  position: relative;
}
tr.edit_row td .edit {
  display: none;
}
tr.edit_row.is-visible td {
  pointer-events: none;
}
tr.edit_row.is-visible td.buttons {
  pointer-events: visible;
}
tr.edit_row.is-visible td .save {
  display: none !important;
}
tr.edit_row.is-visible td .edit {
  display: inline-grid !important;
}
tr.edit_row.is-visible .v-input__append-inner {
  display: none !important;
}
tr.edit_row.is-visible label.v-label.v-label--active.theme--light {
  display: none;
}
</style>
